/*

   To facilitate modifying the program, parts of Builtin.java
   are automatically generated by the program BuildBuiltin.
   This prevents errors in the correspondence between the six
   arrays name[],...,function[k]. The first part of Builtin.java is
   copied by BuildBuiltin from the file BuiltinHead.java.
   BuildBuiltin generates the middle part and then copies the rest
   from the file BuiltinTail.java.

   WARNING: The current version of
            BuildBuiltin overwrites Builtin.java.
*/

import java.lang.*;
import java.util.*;
import java.io.*;

class BuildBuiltin{

 static String[][] table = {
	{",",     "2","2","1","1", "ColcatM","Matrix.colcat"},
	{";",     "2","2","1","1", "RowcatM","Matrix.rowcat"},
	{":",     "2","3","1","1", "RangeM", "Matrix.range"},

	{"+",     "2","2","1","1", "AddE","Scalar.add"},
	{"-",     "1","2","1","1", "SubE","Scalar.subtract"},
	{"*",     "2","2","1","1", "MulM","Matrix.multiply"},
	{"/",     "2","2","1","1", "DivM","Matrix.divide"},
	{"inv",   "1","1","1","1", "InvM","Matrix.inverse"},
	{"'",     "1","1","1","1", "ConjposeM", "Matrix.conjpose"},
	{".'",    "1","1","1","1", "TransposeM","Matrix.transpose"},

	{"==",	  "2","2","1","1", "EquE","Scalar.equ"},
	{"~=",    "2","2","1","1", "NeqE","Scalar.neq"},
	{"<>",    "2","2","1","1", "NeqE","Scalar.neq"}, // duplicate class
	{">",     "2","2","1","1", "GtrE","Scalar.gtr"},
	{">=",    "2","2","1","1", "GeqE","Scalar.geq"},
	{"<",     "2","2","1","1", "LesE","Scalar.les"},
	{"<=",    "2","2","1","1", "LeqE","Scalar.leq"},
	{"&",     "2","2","1","1", "AndE","Scalar.and"},
	{"|",     "2","2","1","1", "OrE","Scalar.or"},
	{"~",     "1","1","1","1", "NotE","Scalar.not"},

	{"^",     "2","2","1","1", "PowerM","Matrix.power"},

	{".*",    "2","2","1","1", "MulE","Scalar.multiply"},
	{"./",    "2","2","1","1", "DivE","Scalar.divide"},
	{".^",    "2","2","1","1", "PowerE","Scalar.power"},
	{"{}",    "2","2","1","1", "CommutatorM","Matrix.commutator"},

	{"rand",  "0","2","1","1", "RandM","Matrix.rand"},
	{"eye",   "1","1","1","1", "EyeM","Matrix.eye"},
	{"zeros", "1","2","1","1", "ZerosM","Matrix.zeros"},
	{"ones",  "1","2","1","1", "OnesM","Matrix.ones"},
	{"size",  "1","1","1","2", "Size",null},


	{"any",   "1","1","1","1", "AnyM","Matrix.any"},
	{"all",   "1","1","1","1", "AllM","Matrix.all"},
	{"sum",   "1","1","1","1", "SumM","Matrix.sum"},
	{"min",   "1","1","1","2", "Min",null},
	{"max",   "1","1","1","2", "Max",null},
	{"diag",  "1","2","1","1", "DiagM","Matrix.diag"},

	{"short",  "0","0","1","1", "ShortF",null},
	{"shorte", "0","0","1","1", "ShorteF",null},
	{"long",   "0","0","1","1", "LongF",null},
	{"longe",  "0","0","1","1", "LongeF",null},


	{"pi",    "0","0","1","1", "PiN",   "Scalar.pi"},
	{"abs",   "1","1","1","1", "AbsN",  "Scalar.abs"},
	{"acos",  "1","1","1","1", "AcosN", "Scalar.acos"},
	{"asin",  "1","1","1","1", "AsinN", "Scalar.asin"},
	{"atan",  "1","1","1","1", "AtanN", "Scalar.atan"},
	{"conj",  "1","1","1","1", "ConjN", "Scalar.conj"},
	{"cos",   "1","1","1","1", "CosN",  "Scalar.cos"},
	{"exp",   "1","1","1","1", "ExpN",  "Scalar.exp"},
	{"fix",   "1","1","1","1", "FixN",  "Scalar.fix"},
	{"imag",  "1","1","1","1", "ImagN", "Scalar.imag"},
	{"log",   "1","1","1","1", "LogN",  "Scalar.log"},
	{"real",  "1","1","1","1", "RealN", "Scalar.real"},
	{"round", "1","1","1","1", "RoundN","Scalar.round"},
	{"sign",  "1","1","1","1", "SignN", "Scalar.sign"},
	{"sin",   "1","1","1","1", "SinN",  "Scalar.sin"},
	{"sqrt",  "1","1","1","1", "SqrtN", "Scalar.sqrt"},
	{"tan",   "1","1","1","1", "TanN",  "Scalar.tan"},

	{"atan2", "2","2","1","1", "Atan2N", "Scalar.atan2"},

	{"expm",  "1","1","1","1", "Exp",null},
	{"lu",    "1","1","1","2", "LUd",null},
	{"det",   "1","1","1","1", "Det",null},
	{"eig",   "1","1","1","2", "Eig",null},
	{"svd",   "1","1","1","3", "SVd",null},
	{"qr",    "1","1","1","2", "QRd",null},



    };//table

    static int val(String s){
        if(s.equals("0")) return 0;
        else
        if(s.equals("1")) return 1;
        else
        if(s.equals("2")) return 2;
        else
           return 3;
    }



    FileOutputStream outfile;

    Vector classNames = new Vector();

    boolean found(String fname){
        for(int i=0; i< classNames.size(); i++)
           if(fname.equalsIgnoreCase((String)classNames.elementAt(i)))
                return true;
        return false;
    }

    public static void main(String[] args)throws IOException{
        new BuildBuiltin();
    }

    private  void check()throws IOException{
            for(int i=0; i<table.length;i++){
                   String s1 = (String) table[i][0];
                   for(int j=i+1;j<table.length;j++){
                        String s2 = (String) table[j][0];
                        if(s1.equals(s2)) put("DUPLICATE ID: "+s1+"="+s2);
                   }
            }
    }


    String indent = "\n      ";

    BuildBuiltin()throws IOException{
        outfile=new FileOutputStream("Builtin.java");
        check();

        fileCatenate("BuiltinHead.java");

        put("\n\n// *** Begin text generated by BuildBuiltin.java\n");
        put("\n// *** WARNING: \":\", \",\", \";\" used in Function\n\n");

        put(" static String[] name = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = "\""+table[i][0]+"\"";
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

        put(" static int[] minArgsin = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = table[i][1];
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

        put(" static int[] maxArgsin = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = table[i][2];
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

        put(" static int[] minArgsout = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = table[i][3];
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

        put(" static int[] maxArgsout = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = table[i][4];
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

        put(" static Builtin[] functions = {");
        for(int i=0; i<table.length;i++){
                if(i%7==0) put(indent);
                String s = "null";
                if(i+1<table.length) s+=","; else s+= indent+"};\n\n";
                while(s.length()<9) s+=" ";
                put(s);
        }

            put(" private static void create(int index){");
            put(indent+"  switch(index){");
        for(int i=0; i<table.length;i++){
                String ss = table[i][5];
            put(indent+"   case "+i+": functions["+i+"] = new "+ss+"();break;");
            }
            put(indent+"  }\n");
            put(indent+"}//create\n");

        put("}//Builtin");


        for(int i=0; i<table.length;i++){
            int min = val(table[i][1]);
            int max = val(table[i][2]);
            String mname = table[i][0];
            String cname = table[i][5];
            String fname = table[i][6];

            if(fname!=null && !found(fname)){
              classNames.addElement(fname);
              put("\nclass "+cname+ " extends Builtin{\n");
              for(int m=min;m<=max;m++){
                if(fname.startsWith("Matrix")){
                    switch(m){
                        case 0: templateM0(cname,fname) ;break;
                        case 1: templateM1(cname,fname) ;break;
                        case 2: templateM2(cname,fname) ;break;
                        case 3: templateM3(cname,fname) ;break;
                        default: put("???");
                    }
                }
                else{
                    switch(m){
                        case 0: templateE0(cname,fname) ;break;
                        case 1: templateE1(cname,fname) ;break;
                        case 2: templateE2(cname,fname,mname) ;break;
                        default: put("???");
                    }
                }
            }
            put("}//"+cname+"\n");
          }
        }

        put("\n// *** End of text generated by BuildBuiltin\n\n");

        fileCatenate("BuiltinTail.java");

        outfile.close();
    }

    void templateE0(String cname, String fname)throws IOException{
    put(indent+"Matrix operate()");
    put(indent+"     throws MinimatException{");
    put(indent+"   Matrix A = new Matrix("+fname+"());");
    put(indent+"   return A;");
    put(indent+"}//operate\n");
    }

    void templateE1(String cname, String fname)throws IOException{
    put(indent+"Matrix operate(Matrix A)");
    put(indent+"     throws MinimatException{");
    put(indent+"   Matrix B = new Matrix(A.nrows,A.ncols);");
    put(indent+"   for(int i=0;i<A.nrows;i++)");
    put(indent+"     for(int j=0;j<A.ncols;j++)");
    put(indent+"       B.entry[i][j] = "+fname+"(A.entry[i][j]);");
    put(indent+"   return B;");
    put(indent+"}//operate\n");
    }

    void templateE2(String cname, String fname, String mname)throws IOException{
    put(indent+"Matrix operate(Matrix A, Matrix B)");
    put(indent+"     throws MinimatException{");
    put(indent+"   Matrix.sameSize(A,B,\""+mname+"\");");
    put(indent+"   Matrix C = new Matrix(A.nrows,A.ncols);");
    put(indent+"   for(int i=0;i<A.nrows;i++)");
    put(indent+"     for(int j=0;j<A.ncols;j++)");;
    put(indent+"       C.entry[i][j] = "+fname+"(A.entry[i][j], B.entry[i][j]);");
    put(indent+"   return C;");
    put(indent+"}//operate\n");
    }
    void templateM0(String cname, String fname)throws IOException{
    put(indent+"Matrix operate()");
    put(indent+"     throws MinimatException{");
    put(indent+"   return "+fname+"();");
    put(indent+"}//operate\n");
    }

    void templateM1(String cname, String fname)throws IOException{
    put(indent+"Matrix operate(Matrix A)");
    put(indent+"     throws MinimatException{");
    put(indent+"   return "+fname+"(A);");
    put(indent+"}//operate\n");
    }

    void templateM2(String cname, String fname)throws IOException{
    put(indent+"Matrix operate(Matrix A, Matrix B)");
    put(indent+"     throws MinimatException{");;
    put(indent+"   return "+fname+"(A,B);");
    put(indent+"}//operate\n");
    }
    void templateM3(String cname, String fname)throws IOException{
    put(indent+"Matrix operate(Matrix A, Matrix B,Matrix C)");
    put(indent+"     throws MinimatException{");;
    put(indent+"   return "+fname+"(A,B,C);");
    put(indent+"}//operate\n");
    }

     void put(String str)throws IOException{
       System.out.print(str);
       for(int x=0; x<str.length();x++)outfile.write(str.charAt(x));
    }

     void fileCatenate(String fname)throws IOException{
        DataInputStream
        d = new DataInputStream(new FileInputStream(new File(fname)));
        for(;;){
            String str = d.readLine();
            if(str==null) break;
            put(str+"\n");
        }
        d.close();
    }


     static void pause() throws IOException{
        System.out.print("Press a key: ");
        System.out.flush();
        int toss = System.in.read();
    }


}//BuildIt