/*
   This creates a java file with an array
     String[][] library:
   library[][0] (names of files in directory mfiles/)
   library[][1]  (text of corresponding file)
*/
import java.lang.*;
import java.util.*;
import java.io.*;

class BuildLibrary{


    static FileOutputStream outfile;
    static File directory;
    static String dirName="mfiles";
    static String libraryName="Library.java";
    static String[] fileNames;

    static public void main(String args[]){
    try{
        outfile=new FileOutputStream(libraryName);
        directory = new File(dirName);
        if(!directory.exists())
            throw new IllegalArgumentException(dirName+" not found");
        if(!directory.isDirectory())
            throw new IllegalArgumentException(dirName+" not a directory");
        fileNames = directory.list();
        put("/*************************************************************\n");
        put(" * The mfiles are prepackaged because so that  MinimatApplet *\n");
        put(" * can load them using DotMFile.loadFromLibrary().           *\n");
        put(" * MinimatApplication loads mfiles from the user.s disk using*\n");
        put(" * DotMFile.loadFromFile(). This file is machine generated   *\n");
        put(" * by BuildLibrary from the *.m files in mfiles.             *\n");
        put(" *************************************************************/\n");
        put("\n public class Library {\n");
        put("\n public static String content[][] = {\n");
        int k;
        for(k=0; k<fileNames.length;k++)
            if(fileNames[k].endsWith(".m")){
                doText(fileNames[k]);
                break;
            }
        for(int i=k+1; i<fileNames.length;i++)
            if(fileNames[i].endsWith(".m")){
                put(",\n");
                doText(fileNames[i]);
            }
        put("\n  };\n}");
        outfile.close();
        pause();
    }catch(IOException e){
        try{put(e.getMessage());} catch(Exception f){}
    }
    }

     static void put(String str)throws IOException{
       System.out.print(str);
       for(int x=0; x<str.length();x++)outfile.write(str.charAt(x));
    }

     static void doText(String fname){
        String indent = "      ";
        DataInputStream d=null;
        try{
        put(indent+"{\""+fname+"\",\n");
        d= new DataInputStream(
           new FileInputStream(
           new File(dirName+File.separator+fname)));

        String str = d.readLine();
        if(str==null) str="";
        put(indent+"  \""+str+"\\n\"");
        for(;;){
            str = d.readLine();
            if(str==null) break;
            put("+\n");
            put(indent+"  \""+str+"\\n\"");
        }
        put("\n"+indent+"}");
        d.close();
        }catch(IOException e){
            try{put(e.getMessage());} catch(Exception f){}
        }
    }


     static void pause(){
        try{
            System.out.print("Press a key: ");
            System.out.flush();
            int toss = System.in.read();
        }catch(IOException e){}

    }

}