

final class Code{
	static final int // opcodes for interpreter


	    //Load and Store
	   	LDM=0,  // load    (= push)          B=A
	   	STM=1,  // store  (= pop)            A=B
	   	MSTM=2, // multiple store            [ A      ]=F()

	   	LDC=3,  // load colon                B=A(:)
	   	STC=4,  // store colon               A(:)=B
	   	MSTC=5, // multiple  "               [ A(:)   ]=F()

	   	LDCS=6, // load colon subscript      B=A(:,j)
	   	STCS=7, // store colon subscript     A(:,j)=B
	   	MSTCS=8,// multiple "                [ A(:,j) ]=F()

	   	LDS=9,  // load subscript            B=A(i)
	   	STS=10,  // store subscript           A(i)=B
	   	MSTS=11, // multiple "                [ A(i)   ]=F()

	   	LDSC=12, // load subscript colon      B=A(i,:)
	   	STSC=13, // store subscript colon     A(i,:)=B
	   	MSTSC=14,// multiple  "               [ A(i,:) ]=F()

	   	LDSS=15, // load subscript subscript  B=A(i,j)
	   	STSS=16, // store subscript subscript A(i,j)=B
	   	MSTSS=17,// multiple "                [ A(i,j) ]=F()

        //control
  	   	BFOR=18,  // begin for
	   	BAT=19,   // bump and test
	   	EFOR=20,  // end for
	   	TST=21,   // test(while loops, if statements)
	   	JMP=22,  // jump   "
	   	BRK=23,  // break out of for or while loop


        // function calls
   		OP0=24,   // Builtin:()-->(*)
  		OP1=25,   // Builtin:(*)-->(*)
   		OP2=26,   // Builtin:(*,*)-->(*)
		OP3=27,   // Builtin:(*,*,*)-->(*)
        SICALL=28,  //simpleInterpretedFunctionCall
		//SBCALL=29,  //simpleBuiltinFunctionCall
	   	MICALL=30, // multipleInterpretedFunctionCall
	   	MBCALL=31,// multipleBuiltinFunctionCall
	   	SETI=32, // set nargin
	   	SETO=33, // set nargout
	   	GETI=34, // get nargin
	   	GETO=35, // get nargout
	   	RTN=36,

   		PRNT=38, // print a variable
   		FRMT=39, // format statement
   		VAL=40,  // real literal
   		INPT=41, // display a msg, input a real
   		OTPT=42, // display a msg and start new line
   		STOP=43, // return control to keyboard
        OPCODELIM=44;

static String dump(int op){
        switch(op){
	   	case Code.LDM:  return "LDM("+op+")";
	   	case Code.STM:  return "STM("+op+")";
	   	case Code.MSTM: return "MSTM("+op+")";

	   	case Code.LDC:  return "LDC("+op+")";
	   	case Code.STC:  return "STC("+op+")";
	   	case Code.MSTC: return "MSTC("+op+")";

	   	case Code.LDCS: return "LDCS("+op+")";
	   	case Code.STCS: return "STCS("+op+")";
	   	case Code.MSTCS:return "MSTCS("+op+")";

	   	case Code.LDS:  return "LDS("+op+")";
	   	case Code.STS:  return "STS("+op+")";
	   	case Code.MSTS: return "MSTS("+op+")";

	   	case Code.LDSC: return "LDSC("+op+")";
	   	case Code.STSC: return "STSC("+op+")";
	   	case Code.MSTSC:return "MSTSC("+op+")";

	   	case Code.LDSS: return "LDSS("+op+")";
	   	case Code.STSS: return "STSS("+op+")";
	   	case Code.MSTSS:return "MSTSS("+op+")";


	   	case Code.BFOR: return "BFOR("+op+")";
	   	case Code.BAT:  return "BAT("+op+")";
	   	case Code.EFOR: return "EFOR("+op+")";
	   	case Code.TST:  return "TST("+op+")";
	   	case Code.JMP:  return "JMP("+op+")";
	   	case Code.BRK:  return "BRK("+op+")";

   		case Code.OP0:  return "OP0("+op+")";
  		case Code.OP1:  return "OP1("+op+")";
  		case Code.OP2:  return "OP2("+op+")";
  		case Code.OP3:  return "OP3("+op+")";
	   	case Code.SICALL: return "SICALL("+op+")";
	   	//case Code.SBCALL:return "SBCALL("+op+")";
	   	case Code.MICALL:return "MICALL("+op+")";
	   	case Code.MBCALL:return "MBCALL("+op+")";
	   	case Code.SETI: return "SETI("+op+")";
	   	case Code.SETO: return "SETO("+op+")";
	   	case Code.GETI: return "GETI("+op+")";
	   	case Code.GETO: return "GETO("+op+")";
	   	case Code.RTN:  return "RTN("+op+")";

   		case Code.PRNT: return "PRNT("+op+")";
   		case Code.FRMT: return "FRMT("+op+")";
   		case Code.VAL:  return "VAL("+op+")";
   		case Code.INPT: return "INPT("+op+")";
   		case Code.OTPT: return "OTPT("+op+")";
   		case Code.STOP: return "STOP("+op+")";
   		default: return "?????????????";
        }
}
}
