
import java.io.*;

class DotMFile{


    static boolean applet=true; // set to false by MinimatApplication.main()
    static String[] searchPath ={"","mfiles"+File.separator};
    private String text=null;
    String fileName;
    String filePath=null;

    DotMFile(String fileName)throws MinimatException{
        this.fileName=fileName;
        if(!applet) loadFromFile();
        else loadFromLibrary();
    }

    boolean exists(){
        return text!=null;
    }

    String getContents()throws MinimatException{
        if(text==null)
         throw new MinimatException("Error reading "+filePath);
        else
         return text;
    }

    private void loadFromFile()throws MinimatException{
        File file=null;
        for(int i=0; i< searchPath.length; i++){
            String path;
            if(searchPath[i]!=null && searchPath[i].length()>0)
                path = searchPath[i]+File.separator;
            else
                path = "";
            file = new File(path+fileName);
            if(file.exists()) break; else file=null;
        }
        if(file==null) {
            text=null;
            filePath=null;
        }else{
            filePath=file.getAbsolutePath();
            FileInputStream inFile=null;
            try{
                inFile = new FileInputStream(file);
      	        int size = (int) file.length();
		        byte[] data= new byte[size];
		        int count = 0;
		        while(count < size)
			        count += inFile.read(data,count,size-count);
		        text = new String(data,0);
		        inFile.close();
		   }catch(IOException e){
            throw new MinimatException(
                "File error while reading  "+filePath+": "+e.getMessage());
           }finally{
		        try{if(inFile!=null) inFile.close();}catch(IOException e){}
           }
        }
    }

    private void loadFromLibrary(){
        for(int i=0;i<Library.content.length; i++){
            if(fileName.equalsIgnoreCase(Library.content[i][0])){
                    text=Library.content[i][1];
                    filePath="Library.mfiles/"+fileName;
                    return;
            }
        }
    }

}//DotMFile