
import java.awt.*;
import java.applet.*;
import java.lang.Math;
import java.util.Vector;

public class MinimatApplet extends Applet {


    TextArea input;
    TextArea output;
    Button xButton,dButton;
    static String inPrompt  = "$> ";
    static String outPrompt = "@> ";

    public void init() {

    Global.Initialize(this);

    input  = new TextArea(inPrompt,3,60);
    input.setFont(new Font("Courier",Font.BOLD,12));
    output  = new TextArea(10,60);
    output.setFont(new Font("Courier",Font.PLAIN,12));
    output.setEditable(false);
    xButton = new Button("Execute");
    dButton = new Button("Dump");

    GridBagLayout gbl = new GridBagLayout();
	setLayout(gbl);
    GridBagConstraints gbc = new GridBagConstraints();

    gbc.anchor = GridBagConstraints.NORTH;
    gbc.ipadx = 10;  gbc.ipady = 10;
    gbc.insets = new Insets(10,10,10,10);

 	gbc.fill = GridBagConstraints.BOTH;

    gbc.gridheight = 1; gbc.gridwidth = 1;
    gbc.gridx = 1; gbc.gridy = 1;
	gbl.setConstraints(input,gbc);
    add(input);

    gbc.gridheight = 1; gbc.gridwidth = 1;
    gbc.gridx = 1; gbc.gridy = 2;
	gbl.setConstraints(xButton,gbc);
    add(xButton);
/*
    gbc.gridheight = 1; gbc.gridwidth = 1;
    gbc.gridx = 2; gbc.gridy = 2;
	gbl.setConstraints(dButton,gbc);
    add(dButton);
*/
    gbc.gridheight = 1; gbc.gridwidth = 1;
    gbc.gridx = 1; gbc.gridy = 3;
	gbl.setConstraints(output,gbc);
    add(output);
    }



    public boolean action(Event e, Object arg){
	    if (e.target.equals(xButton)){
	       try{
	        String text = input.getText();
	        // We must discard the inPrompt.
	        // Perhaps the user has already deleted it
	        // or has accidentally inserted the outPrompt
	        // by cut and paste. We'll discard all
	        // unwanted characters at the front of text.
	        int n;
	        for(n=0; n<text.length(); n++){
	             char ch = text.charAt(n);
	             if(ch!=' ' && ch!='$' && ch!='@' && ch!='>') break;
	        }
	        text = text.substring(n);
	        //
	        Global.primeDirective(text);
	        input.setText(inPrompt);
	        } catch (Exception ex){
	        output.appendText(ex.getMessage()+"\n");
	        ex.printStackTrace();
	        }
	        finally{
	        return true;
	       }
	    }else
	    if (e.target.equals(dButton)){
	        Global.dump();
	        input.setText(inPrompt);
	        return true;
	    }else
	        return false;
	}

}
