

 final class Token{
	 static final int
		LPAREN=0, LBRACK=1,  LCURLY=2, RPAREN=3, RBRACK=4, RCURLY=5,
		COLSEP=6, ROWSEP=7, ARGSEP=8, COMMA=9, SEMICOLON=10,
		POSTOP=11, EXPOP=12, MULOP=13, ADDOP=14, COLON=15,
		RELOP=16, NEGOP=17, LOGOP=18, GETS=19,
		IFW=20, FORW=21, FORMATW=22, WHILEW=23, ELSEW=24, ELSEIFW=25,
		ENDW=26, FUNCTIONW=27, BREAKW=28, RETURNW=29, DISPW=30, INPUTW=31,
		NARGINW=32, NARGOUTW=33,
		ID=34, VARID=35, BFNID=36, IFNID=37, NEWID=38,
		NUMBER=39, PSTRING=40,
		EOL=41, EOT=42,
		ERR=43;


    // A String will be parsed into a Vector of Tokens.
	 int symbol;   // Token.XXX
	 int beginIndex;
     String text;

    Token(int symbol, int beginIndex, int endIndex,String ambientText){
        this.symbol=symbol;
        this.beginIndex=beginIndex;
        text= ambientText.substring(beginIndex,endIndex);
    }

     int lineNumber(String ambientText){
        int lno=1;
        for(int x=0;x<ambientText.length()&& x<beginIndex;x++){
            if(ambientText.charAt(x)=='\n') lno++;
        }
        return lno;
    }



	 String toString(String ambientText){ // for debugging
	  String str = "";
	  str +=lineNumber(ambientText);
	  while(str.length()<4) str=" "+str;
	  str += " ["+ text.length()+"]";
	  while(str.length()<10) str=" "+str;
	  str+=" \"";
	  str += text;
	  str+="\" ";
	  while(str.length()<25) str+=" ";
	  switch(symbol){
       case  Token.LPAREN:     str += "LPAREN";    break;
       case  Token.LBRACK:     str += "LBRACK";    break;
       case  Token.LCURLY:     str += "LCURLY";    break;
       case  Token.RPAREN:     str += "RPAREN";    break;
       case  Token.RBRACK:     str += "RBRACK";    break;
       case  Token.RCURLY:     str += "RCURLY";    break;
       case  Token.COLSEP:     str += "COLSEP";    break;
       case  Token.ROWSEP:     str += "ROWSEP";    break;
       case  Token.ARGSEP:     str += "ARGSEP";    break;
       case  Token.COMMA:      str += "COMMA";     break;
       case  Token.SEMICOLON:  str += "SEMICOLON"; break;
       case  Token.POSTOP:     str += "POSTOP";    break;
       case  Token.EXPOP:      str += "EXPOP";     break;
       case  Token.MULOP:      str += "MULOP";     break;
       case  Token.ADDOP:      str += "ADDOP";     break;
       case  Token.COLON:      str += "COLON";     break;
       case  Token.RELOP:      str += "RELOP";     break;
       case  Token.NEGOP:      str += "NEGOP";     break;
       case  Token.LOGOP:      str += "LOGOP";     break;
       case  Token.GETS:       str += "GETS";      break;
       case  Token.IFW:        str += "IFW";       break;
       case  Token.FORW:       str += "FORW";      break;
       case  Token.FORMATW:    str += "FORMATW";   break;
       case  Token.WHILEW:     str += "WHILEW";    break;
       case  Token.ELSEW:      str += "ELSEW";     break;
       case  Token.ELSEIFW:    str += "ELSEIFW";   break;
       case  Token.ENDW:       str += "ENDW";      break;
       case  Token.FUNCTIONW:  str += "FUNCTIONW"; break;
       case  Token.BREAKW:     str += "BREAKW";    break;
       case  Token.RETURNW:    str += "RETURNW";   break;
       case  Token.DISPW:      str += "DISPW";     break;
       case  Token.INPUTW:     str += "INPUTW";    break;
       case  Token.NARGINW:    str += "NARGINW";   break;
       case  Token.NARGOUTW:   str += "NARGOUTW";  break;
       case  Token.ID:         str += "ID";        break;
       case  Token.VARID:      str += "VARID";     break;
       case  Token.BFNID:      str += "BFNID";     break;
       case  Token.IFNID:      str += "IFNID";     break;
       case  Token.NEWID:      str += "NEWID";     break;
       case  Token.NUMBER:     str += "NUMBER";    break;
       case  Token.PSTRING:    str += "PSTRING";   break;
       case  Token.EOL:        str += "EOL";       break;
       case  Token.EOT:        str += "EOT";       break;
       case  Token.ERR:        str += "ERR";       break;
       default: str += "????!??!?!@?$#";
	}// switch
	while(str.length()<=35) str+=" ";
	str+="= ";
	str += symbol;
	return str;
	}// toString
}//Token

